// 003 u_script_executer_with_blobs
// 22 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_script_executer_with_blobs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, IBDatabase, DB, IBSQL, IBExtract,
  IBCustomDataSet, IBQuery, Grids, DBGrids, DBCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    dir_: TTabSheet;
    insert_: TTabSheet;
    exit_: TButton;
    clear_: TButton;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBSQL1: TIBSQL;
    PageControl2: TPageControl;
    display_: TTabSheet;
    script__: TTabSheet;
    Memo1: TMemo;
    Panel3: TPanel;
    script_memo_: TMemo;
    IBQuery1: TIBQuery;
    base_directory_listbox_: TDirectoryListBox;
    base_file_listbox_: TFileListBox;
    script_directory_listbox_: TDirectoryListBox;
    script_file_listbox_: TFileListBox;
    original_script_: TTabSheet;
    original_memo_: TMemo;
    DataSource1: TDataSource;
    dbgrid_: TTabSheet;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    DBMemo3: TDBMemo;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    IBQuery2: TIBQuery;
    non_html_: TTabSheet;
    non_html_memo_: TMemo;
    trimmed_request_: TTabSheet;
    trimmed_request_memo_: TMemo;
    Panel6: TPanel;
    create_database_: TButton;
    create_table_: TButton;
    display_table_: TButton;
    drop_table_: TButton;
    Panel5: TPanel;
    insert_blobs_: TButton;
    execute_: TCheckBox;
    table_name_listbox_: TListBox;
    display_table_2_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure base_file_listbox_Click(Sender: TObject);
    procedure script_directory_listbox_Change(Sender: TObject);
    procedure script_file_listbox_Click(Sender: TObject);
    procedure base_directory_listbox_Change(Sender: TObject);
    procedure create_database_Click(Sender: TObject);
    procedure create_table_Click(Sender: TObject);
    procedure display_table_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure insert_blobs_Click(Sender: TObject);
    procedure display_table_2_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_file, u_dir
        , u_c_ini_file
        , u_strings
        , u_ibx, u_ib_script, u_db
        , u_c_ib_script
        , u_c_insert_ib_blob
        , u_c_field_value_list
        ;

    {$R *.DFM}

   
    const k_initial_path= 'c:\prog\uti_del\shell\';
            k_file_name= 'e.ed';
            k_extension= '.*';
    const k_table_name= 'JOBS';

          // -- ini keys
          k_save_path= k_initial_path;
          k_save_name= k_file_name;

          k_load_base_path_ini_key=      'load_base_path';
          k_load_base_file_name_ini_key= 'load_base_file_name';
          k_load_script_path_ini_key=      'load_script_path';
          k_load_script_file_name_ini_key= 'load_script_file_name';
          k_load_script_table_name_ini_key= 'load_script_table_name';

          k_root_path= 'C:\programs\fr\bdd\interbase\_data\employee\';
          k_database_path= k_root_path+ '__data\';
            k_database_name= 'EMPLOYEE_6.GDB';

          k_script_path= k_root_path+ '__data\schema\';
          k_script_insert_into_path= 'data\';

    var g_script_path: String= k_initial_path;
        g_script_file_name: String= k_file_name;

        g_base_path: String= k_initial_path;
        g_base_file_name: String= k_file_name;

        g_table_name: String= k_table_name;

        g_c_ini_file: c_ini_file= Nil;

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      var l_index_of_script: Integer;
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_base_path:= f_initialize_parameter(k_load_base_path_ini_key, k_save_path);
          display(g_base_path);
          g_base_file_name:= f_initialize_parameter(k_load_base_file_name_ini_key, k_save_name);

          g_script_path:= f_initialize_parameter(k_load_script_path_ini_key, k_save_path);
          g_script_file_name:= f_initialize_parameter(k_load_script_file_name_ini_key, k_save_name);

          g_table_name:=  f_initialize_parameter(k_load_script_table_name_ini_key, k_table_name);
        end;

        set_directory_listbox_directory(base_directory_listbox_, g_base_path);
        set_directory_listbox_directory(script_directory_listbox_, g_script_path);
        script_file_listbox_.Mask:= '*'+ k_extension;

        // display(g_script_file_name);
        with script_file_listbox_, Items do
        begin
          l_index_of_script:= IndexOf(g_script_file_name);
          // display(IntToStr(l_index_of_script));
          If l_index_of_script>= 0
            then ItemIndex:= l_index_of_script;
        end;
        with base_file_listbox_, Items do
        begin
          l_index_of_script:= IndexOf(g_base_file_name);
          // display(IntToStr(l_index_of_script));
          If l_index_of_script>= 0
            then ItemIndex:= l_index_of_script;
        end;

        Caption:= g_base_path+ g_base_file_name;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.base_directory_listbox_Change(Sender: TObject);
      begin
        with base_directory_listbox_ do
          g_base_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_base_path_ini_key, g_base_path);
      end; // base_directory_listbox_Change

    procedure TForm1.base_file_listbox_Click(Sender: TObject);
        // -- the file clicked in the bottom list_box
      begin
        with base_file_listbox_ do
          g_base_file_name:= Items[ItemIndex];
        initialize_ib_database(g_base_path+ g_base_file_name, 'SYSDBA', 'masterkey', IbDatabase1);
        f_open_ib_database('open', IbDatabase1);

        g_c_ini_file.set_parameter(k_load_base_file_name_ini_key, g_base_file_name);
        Caption:= g_base_path+ g_base_file_name;
      end; // base_file_listbox_

    procedure TForm1.script_directory_listbox_change(Sender: TObject);
      begin
        with script_directory_listbox_ do
          g_script_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_script_path_ini_key, g_script_path);
      end; // script_directory_listbox_change

    procedure TForm1.script_file_listbox_Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      begin
        with script_file_listbox_ do
          g_script_file_name:= Items[ItemIndex];
        display(g_script_path+ ' '+ g_script_file_name);
        g_c_ini_file.set_parameter(k_load_script_file_name_ini_key, g_script_file_name);

        original_memo_.Lines.LoadFromFile(g_script_path+ g_script_file_name);

        display_line;
        display('finished');
      end; // script_file_listbox_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    // -- trial database

    const k_test_database_name= 'ib_test_6.gdb';
          k_user= 'SYSDBA';
          k_password= 'masterkey';

          k_test_table_name= 'JOB';
          k_create_test_table=
               ' CREATE TABLE '+ k_test_table_name
              + '  ('
              + '      JOB_CODE VARCHAR(5)'
              + '    , JOB_GRADE SMALLINT'
              + '    , JOB_COUNTRY VARCHAR(15)'
              + '    , JOB_TITLE VARCHAR(25)'
              + '    , MIN_SALARY NUMERIC(15, 2)'
              + '    , MAX_SALARY NUMERIC(15, 2)'
              + '    , JOB_REQUIREMENT BLOB SUB_TYPE TEXT SEGMENT SIZE 400'
              // NO do not use: ARRAY field type
              // --  + '    , LANGUAGE_REQ VARCHAR(15)' // [1:5]'
              + '  )'
              ;
          k_drop_test_table= 'DROP TABLE '+ k_test_table_name;
          k_select_test_table= 'SELECT * FROM '+ k_test_table_name;

          k_test_table_name_2= 'PROJECT';
          k_create_test_table_2=
               ' CREATE TABLE '+ k_test_table_name_2
              + '  ('
              + '      PROJ_ID CHAR(5) ,'
              + '      PROJ_NAME VARCHAR(20) NOT NULL,'
              + '      PROJ_DESC BLOB SUB_TYPE TEXT SEGMENT SIZE 800,'
              + '      TEAM_LEADER SMALLINT,'
              + '      PRODUCT VARCHAR(12)'
              + '  )'
              ;
          k_drop_test_table_2= 'DROP TABLE '+ k_test_table_name_2;
          k_select_test_table_2= 'SELECT * FROM '+ k_test_table_name_2;

    procedure TForm1.create_database_Click(Sender: TObject);
      begin
        if f_create_ib_database(g_base_path+ k_test_database_name, k_user, k_password, IbDataBase1)
          then display('ok_create_database '+ g_base_path+ k_test_database_name);
      end; // create_database_Click

    procedure TForm1.create_table_Click(Sender: TObject);
      begin
        display(k_create_test_table);
        if f_execute_ibsql(IbSql1, k_create_test_table)
          then display('ok_create_job');
        if f_execute_ibsql(IbSql1, k_create_test_table_2)
          then display('ok_create_project');
      end; // create_table_Click

    procedure TForm1.display_table_Click(Sender: TObject);
      begin
        dbMemo1.DataField:= '';
        open_ibquery(IbQuery2, k_select_test_table);
        dbMemo1.DataField:= 'JOB_REQUIREMENT';
      end; // display_table_Click

    procedure TForm1.display_table_2_Click(Sender: TObject);
      begin
        dbMemo1.DataField:= '';
        open_ibquery(IbQuery2, k_select_test_table_2);
        dbMemo1.DataField:= 'PROJ_DESC';
      end; // display_table_2_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        if f_execute_ibsql(IbSql1, k_drop_test_table)
          then display('ok_drop_job');
        if f_execute_ibsql(IbSql1, k_drop_test_table_2)
          then display('ok_drop_project');
      end; // drop_table_Click

    // -- add blobs from several tables

    procedure TForm1.insert_blobs_Click(Sender: TObject);
      begin
        with c_insert_ib_blob.create_insert_ib_blob('trial', IbDatabase1) do
        begin
          m_exec_sql:= execute_.Checked;
          execute_script(g_script_path+ g_script_file_name);

          table_name_listbox_.Items.Assign(m_c_table_name_list);

          Free;
        end;
      end; // insert_blobs_Click

end.


