// 012 u_display_hex
// 03 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r-*)

unit u_display_hex;
  interface
    uses classes;

    function f_integer_to_hex(p_integer: Integer): String;
    function f_small_integer_to_hex(p_small_int: SmallInt): String;
    function f_word_to_hex(p_word: Integer): String;

    procedure display_memory_hex(p_pt: Pointer; p_count, p_columns: Integer; p_c_strings: tStrings);
    procedure display_hex(p_pt: Pointer; p_count, p_columns: Integer);
    procedure display_hex_only(p_pt: Pointer; p_count, p_columns: Integer);
    //   with relative buffer address
    procedure display_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer);
    procedure display_address_and_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer);
    function f_address_and_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer): String;

    procedure display_index_and_buffer_hex(p_pt: Pointer; p_count, p_columns, p_start_index: Integer);
    procedure display_address_and_index_and_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer);

    function f_guid_to_string(p_guid: tGuid): String;

  implementation
    uses SysUtils, u_loaded, u_c_display;

    procedure start;
      // do NOT remove: debug
      begin
      end; // start

    // -- scalar conversions

    function f_integer_to_hex(p_integer: Integer): String;
      var l_index: Integer;
      begin
        Result:= IntToHex(p_integer, 4);
        for l_index:= Length(Result)+ 1 to 8 do
          Result:= '0'+ Result;
        Insert('.', Result, 5);
      end; // f_integer_to_hex

    function f_small_integer_to_hex(p_small_int: SmallInt): String;
      var l_index: Integer;
      begin
        Result:= IntToHex(p_small_int, 2);
        for l_index:= Length(Result)+ 1 to 4 do
          Result:= '0'+ Result;
      end; // f_small_integer_to_hex

    function f_word_to_hex(p_word: Integer): String;
      var l_index: Integer;
      begin
        Result:= IntToHex(p_word, 2);
        for l_index:= Length(Result)+ 1 to 4 do
          Result:= '0'+ Result;
      end; // f_word_to_hex

    // -- memory conversion

    procedure display_memory_hex(p_pt: Pointer; p_count, p_columns: Integer; p_c_strings: tStrings);
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
      begin
        with p_c_strings do
        begin
          l_texte:= ''; l_ascii:= '';

          l_adresse:= Integer(p_pt);
          l_start_of_line_index:= 0;

          for l_indice:= 0 to p_count- 1 do
          begin
            l_octet:= t_pt_octets(p_pt)^[l_indice];

            l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
            case l_octet of
              0..31 : l_ascii:= l_ascii+ '.';
              else
                l_ascii:= l_ascii+ chr(l_octet);
            end;

            if (l_indice+ 1) mod p_columns= 0
              then begin
                  Add(IntToHex(l_start_of_line_index, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');

                  l_texte:= ''; l_ascii:= '';
                  Inc(l_adresse, p_columns);
                  Inc(l_start_of_line_index, p_columns);
                end;
          end; // for

          Add(IntToHex(l_start_of_line_index, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');
        end; // with
      end; // display_memory_hex

    procedure display_hex(p_pt: Pointer; p_count, p_columns: Integer);
        // the "__" are correct (28 mar 2001)
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
      begin
        display('display_hex');
        l_texte:= ''; l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // the first part, up to mod p_col
        l_modulo:= l_adresse mod p_columns;

        display('l_adresse '+ IntToStr(l_adresse)
            + ' $'+ IntToHex(l_adresse, 4)
            + ' mod '+ IntToStr(l_modulo));

        for l_indice:= 0 to l_modulo- 1 do
        begin
          l_ascii:= l_ascii+ '_';
          l_texte:= l_texte+ '___';
        end;

        Dec(l_adresse, l_modulo);
        Inc(p_count, l_modulo);
        p_pt:= Pointer(l_adresse);

        for l_indice:= l_modulo to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                display(IntToHex(l_start_of_line_index, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');

                l_texte:= ''; l_ascii:= '';
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
              end;
        end; // for

        // finish the line up to the modulo p_columns
        l_modulo:= (l_adresse+ p_count- 1) mod p_columns;
        for l_indice:= l_modulo+ 1 to p_columns- 1 do
        begin
          l_ascii:= l_ascii+ '_';
          l_texte:= l_texte+ '___';
        end;
        display(IntToHex(l_start_of_line_index, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');
      end; // display_hex

    procedure display_hex_only(p_pt: Pointer; p_count, p_columns: Integer);
        // the "__" are correct (28 mar 2001)
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          // l_texte,
          l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
      begin
        display('display_hex');
        l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // the first part, up to mod p_col
        l_modulo:= l_adresse mod p_columns;

        display('l_adresse '+ IntToStr(l_adresse)
            + ' $'+ IntToHex(l_adresse, 4)
            + ' mod '+ IntToStr(l_modulo));

        for l_indice:= 0 to l_modulo- 1 do
        begin
          l_ascii:= l_ascii+ '_';
        end;

        Dec(l_adresse, l_modulo);
        Inc(p_count, l_modulo);
        p_pt:= Pointer(l_adresse);

        for l_indice:= l_modulo to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                display(IntToHex(l_start_of_line_index, 4)+ ': '+ l_ascii+ '<');

                l_ascii:= '';
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
              end;
        end; // for

        // finish the line up to the modulo p_columns
        l_modulo:= (l_adresse+ p_count- 1) mod p_columns;
        for l_indice:= l_modulo+ 1 to p_columns- 1 do
        begin
          l_ascii:= l_ascii+ '_';
        end;
        display(IntToHex(l_start_of_line_index, 4)+ ': '+ l_ascii+ '<');
      end; // display_hex_only

    procedure display_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer);
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
          l_column: Integer;
      begin
        l_column:= 0;
        l_texte:= ''; l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // always starts at 0: no modulo adjustement

        for l_indice:= 0 to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          Inc(l_column);
          if l_column= 8
            then begin
                l_texte:= l_texte+ ' ';
                l_ascii:= l_ascii+ ' ';
              end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                display(IntToHex(l_start_of_line_index, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');

                l_texte:= ''; l_ascii:= ''; l_column:= 0;
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
              end;
        end; // for

        // finish the line up to the modulo p_columns
        l_modulo:= p_count mod p_columns;
        if l_modulo<> 0
          then begin
              l_modulo:= p_columns- l_modulo;
              for l_indice:= 0 to l_modulo- 1 do
              begin
                l_ascii:= l_ascii+ '_';
                l_texte:= l_texte+ '___';

                Inc(l_column);
                if l_column= 8
                  then begin
                      l_texte:= l_texte+ ' ';
                      l_ascii:= l_ascii+ ' ';
                    end;
              end;
            end;
        if l_ascii<> ''
          then display(IntToHex(l_start_of_line_index, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');
      end; // display_buffer_hex

    procedure display_address_and_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer);
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
          l_column: Integer;
      begin
        l_column:= 0;
        l_texte:= ''; l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // always starts at 0: no modulo adjustement
        for l_indice:= 0 to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          Inc(l_column);
          if l_column= 8
            then begin
                l_texte:= l_texte+ ' ';
                l_ascii:= l_ascii+ ' ';
              end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                display(f_integer_to_hex(l_adresse)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');

                l_texte:= ''; l_ascii:= ''; l_column:= 0;
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
              end;
        end; // for

        // finish the line up to the modulo p_columns
        l_modulo:= p_count mod p_columns;
        if l_modulo<> 0
          then begin
              l_modulo:= p_columns- l_modulo;
              for l_indice:= 0 to l_modulo- 1 do
              begin
                l_ascii:= l_ascii+ '_';
                l_texte:= l_texte+ '___';

                Inc(l_column);
                if l_column= 8
                  then begin
                      l_texte:= l_texte+ ' ';
                      l_ascii:= l_ascii+ ' ';
                    end;
              end;
            end;
        if l_ascii<> ''
          then display(f_integer_to_hex(l_adresse)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');
      end; // display_address_and_buffer_hex

    function f_address_and_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer): String;
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
          l_column: Integer;
          l_lines: Integer;
      begin
        Result:= '';
        l_lines:= 0;

        l_column:= 0;
        l_texte:= ''; l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // -- always starts at 0: no modulo adjustement

        for l_indice:= 0 to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          Inc(l_column);
          if l_column= 8
            then begin
                l_texte:= l_texte+ ' ';
                l_ascii:= l_ascii+ ' ';
              end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                if l_lines> 0
                  then Result:= Result+ #13#10;
                Result:= Result+ IntToHex(l_adresse, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<';
                Inc(l_lines);

                l_texte:= ''; l_ascii:= ''; l_column:= 0;
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
              end;
        end; // for

        // -- finish the line up to the modulo p_columns
        l_modulo:= p_count mod p_columns;
        if l_modulo<> 0
          then begin
              l_modulo:= p_columns- l_modulo;
              for l_indice:= 0 to l_modulo- 1 do
              begin
                l_ascii:= l_ascii+ '_';
                l_texte:= l_texte+ '___';

                Inc(l_column);
                if l_column= 8
                  then begin
                      l_texte:= l_texte+ ' ';
                      l_ascii:= l_ascii+ ' ';
                    end;
              end;
            end;

        if l_ascii<> ''
          then begin
              if l_lines> 0
                then Result:= Result+ #13#10;
              Result:= Result+ IntToHex(l_adresse, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<';
            end;
      end; // f_address_and_buffer_hex

    procedure display_index_and_buffer_hex(p_pt: Pointer; p_count, p_columns, p_start_index: Integer);
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
          l_column: Integer;
      begin
        l_column:= 0;
        l_texte:= ''; l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // -- always starts at 0: no modulo adjustement

        for l_indice:= 0 to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          Inc(l_column);
          if l_column= 8
            then begin
                l_texte:= l_texte+ ' ';
                l_ascii:= l_ascii+ ' ';
              end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                display(IntToHex(p_start_index+ l_indice, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');

                l_texte:= ''; l_ascii:= ''; l_column:= 0;
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
              end;
        end; // for

        // -- finish the line up to the modulo p_columns
        l_modulo:= p_count mod p_columns;
        if l_modulo<> 0
          then begin
              l_modulo:= p_columns- l_modulo;
              for l_indice:= 0 to l_modulo- 1 do
              begin
                l_ascii:= l_ascii+ '_';
                l_texte:= l_texte+ '___';

                Inc(l_column);
                if l_column= 8
                  then begin
                      l_texte:= l_texte+ ' ';
                      l_ascii:= l_ascii+ ' ';
                    end;
              end;
            end;

        if l_ascii<> ''
          then display(IntToHex(p_start_index+ l_indice, 4)+ ': '+ l_texte+ ' : '+ l_ascii+ '<');
      end; // display_index_and_buffer_hex

    procedure display_address_and_index_and_buffer_hex(p_pt: Pointer; p_count, p_columns: Integer);
      type t_octets= array[0..0] of byte;
           t_pt_octets= ^t_octets;
      var l_indice: Integer;
          l_texte, l_ascii: String;
          l_octet: Byte;
          l_adresse: Integer;
          l_start_of_line_index: Integer;
          l_modulo: Integer;
          l_column: Integer;
          l_offset: Integer;
      begin
        l_column:= 0;
        l_texte:= ''; l_ascii:= '';

        l_adresse:= Integer(p_pt);
        l_start_of_line_index:= 0;

        // -- always starts at 0: no modulo adjustement
        l_offset:= 0;

        for l_indice:= 0 to p_count- 1 do
        begin
          l_octet:= t_pt_octets(p_pt)^[l_indice];

          l_texte:= l_texte+ IntToHex(l_octet, 2)+ ' ';
          case l_octet of
            0..31 : l_ascii:= l_ascii+ '.';
            else
              l_ascii:= l_ascii+ chr(l_octet);
          end;

          Inc(l_column);
          if l_column= 8
            then begin
                l_texte:= l_texte+ ' ';
                l_ascii:= l_ascii+ ' ';
              end;

          if (l_indice+ 1) mod p_columns= 0
            then begin
                display(f_integer_to_hex(l_adresse)
                    + ' ('+ IntToHex(l_offset, 2)+ ')'
                    + ': '+ l_texte+ ' : '+ l_ascii+ '<');

                l_texte:= ''; l_ascii:= ''; l_column:= 0;
                Inc(l_adresse, p_columns);
                Inc(l_start_of_line_index, p_columns);
                Inc(l_offset, p_columns);
              end;
        end; // for

        // -- finish the line up to the modulo p_columns
        l_modulo:= p_count mod p_columns;
        if l_modulo<> 0
          then begin
              l_modulo:= p_columns- l_modulo;
              for l_indice:= 0 to l_modulo- 1 do
              begin
                l_ascii:= l_ascii+ '_';
                l_texte:= l_texte+ '___';

                Inc(l_column);
                if l_column= 8
                  then begin
                      l_texte:= l_texte+ ' ';
                      l_ascii:= l_ascii+ ' ';
                    end;
              end;
            end;
        if l_ascii<> ''
          then display(f_integer_to_hex(l_adresse)
                  + ' ('+ IntToHex(l_offset, 2)+ ')'
                  + ': '+ l_texte+ ' : '+ l_ascii+ '<');
      end; // display_address_and_index_and_buffer_hex

    // -- guid, because Kylix did not have this

    function f_guid_to_string(p_guid: tGuid): String;
      (*
      TGUID = packed record
        D1: LongWord;
        D2: Word;
        D3: Word;
        D4: array[0..7] of Byte;
      end;
      *)
      var l_byte: Integer;
      begin
        with p_guid do
        begin
          Result:= f_integer_to_hex(Integer(D1))
            + '-'+ f_small_integer_to_hex(D2)
            + '-'+ f_small_integer_to_hex(D3)
            + '-';
          for l_byte:= 0 to 7 do
            Result:= Result+ IntToHex(D4[l_byte], 1);
        END;
      end; // f_uid_to_string

    begin // u_display_hex
      display_loaded('u_display_hex', @start);
    end. // u_display_hex

